task hisat2 {
   File idx
   File read_1P
   File read_2P
   String idx_prefix
   String base=sub(basename(read_1P),"\\.\\S+$", "")
   String docker
   String cluster
   String disk_size
   

   command {
      nt=$(nproc)
      hisat2 -t -p $nt -x ${idx}/${idx_prefix} -1 ${read_1P} -2 ${read_2P} -S ${base}.sam  --un-conc-gz ${base}_un.fq.gz
   }
   
   runtime { 
      docker: docker 
      cluster: cluster
      systemDisk: "cloud_ssd 40"
      dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
   }

   output {
      File sam=base + ".sam"
      File unmapread_1p=base + "_un.fq.1.gz"
      File unmapread_2p=base + "_un.fq.2.gz"
   }
}
