task samtools {
    File sam
    String base=basename(sam, ".sam")
    String bam=base + ".bam"
    String sorted_bam=base + ".sorted.bam"
    String sorted_bam_index=base + ".sorted.bam.bai"
    String percent_bam=base + ".percent.bam"
    String samstats=base + ".samstats"
    String ins_size=base + ".ins_size" 
    String docker
    String cluster
    String disk_size
    Int insert_size

    command <<<
       set -o pipefail
       set -e
       /opt/conda/bin/samtools view -bS ${sam} > ${bam}
       /opt/conda/bin/samtools sort -m 1000000000 ${bam} -o ${sorted_bam}
       /opt/conda/bin/samtools index ${sorted_bam}
       /opt/conda/bin/samtools view -bs 42.1 ${sorted_bam} > ${percent_bam}
       /opt/conda/bin/samtools stats ${sorted_bam} > ${samstats}
       /opt/conda/bin/samtools stats -i ${insert_size} ${sorted_bam} |grep ^IS|cut -f 2- > ${ins_size}

    >>>

    runtime {
       docker: docker
       cluster: cluster
       systemDisk: "cloud_ssd 40"
       dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"
    }

    output {
       File out_sort_bam=sorted_bam
       File out_sort_bam_index=sorted_bam_index
       File out_percent = percent_bam
       File out_samstats=samstats
       File out_ins_size=ins_size
    }

}

